TOUCH(1)

NAME
touch - change file access and modification times

SYNOPSIS
touch [-A [-][[hh]mm]SS] [-achm] [-r file] [-t [[CC]YY]MMDDhhmm[.SS]] [-d YYYY-MM-DDThh:mm:SS[.frac][tz]] file ...

DESCRIPTION
The touch utility sets the modification and access times of files. If any file does not exist, it is created with default permissions.

By default, touch changes both modification and access times. The -a and -m flags may be used to select the access time or the modification time individually. Selecting both is equivalent to the default. By default, the timestamps are set to the current time. The -d and -t flags explicitly specify a different time, and the -r flag specifies to set the times those of the specified file. The -A flag adjusts the values by a specified amount.

The following options are available:

-A  Adjust the access and modification time stamps for the file by the specified value. This flag is intended for use in modifying files with incorrectly set time stamps.

    The argument is of the form “[-][[hh]mm]SS” where each pair of letters represents the following:

    -   Make the adjustment negative: the new time stamp is set to be before the old one.
    hh  The number of hours, from 00 to 99.
    mm  The number of minutes, from 00 to 59.
    SS  The number of seconds, from 00 to 59.

    The -A flag implies the -c flag: if any file specified does not exist, it will be silently ignored.

-a  Change the access time of the file. The modification time of the file is not changed unless the -m flag is also specified.

-c  Do not create the file if it does not exist. The touch utility does not treat this as an error. No error messages are displayed and the exit value is not affected.

-d  Change the access and modification times to the specified time instead of the current time of day. The argument is of the form “YYYY-MM-DDThh:mm:SS[.frac][tz]” where the letters represent the following:
    YYYY
        The year.
    MM  The month of the year, from 01 to 12.
    DD  The day of the month, from 01 to 31.
    T   The letter T or a space.
    hh  The hour of the day, from 00 to 23.
    mm  The minute of the hour, from 00 to 59.
    SS  The second of the minute, from 00 to 61.
    .frac
        An optional fraction, consisting of a period or a comma followed by one or more digits. The number of significant digits depends on the kernel configuration and the filesystem, and may be zero.
    tz  An optional letter Z indicating the time is in UTC. Otherwise, the time is assumed to be in local time.

-h  If the file is a symbolic link, change the times of the link itself rather than the file that the link points to. Note that -h implies -c and thus will not create any new files.

-m  Change the modification time of the file. The access time of the file is not changed unless the -a flag is also specified.

-r  Use the access and modifications times from the specified file instead of the current time of day.

-t  Change the access and modification times to the specified time instead of the current time of day. The argument is of the form “[[CC]YY]MMDDhhmm[.SS]” where each pair of letters represents the following:

    CC  The first two digits of the year (the century).
    YY  The second two digits of the year. If “YY” is specified, but “CC” is not, a value for “YY” between 69 and 99 results in a “CC” value of 19. Otherwise, a “CC” value of 20 is used.
    MM  The month of the year, from 01 to 12.
    DD  the day of the month, from 01 to 31.
    hh  The hour of the day, from 00 to 23.
    mm  The minute of the hour, from 00 to 59.
    SS  The second of the minute, from 00 to 61.

    If the “CC” and “YY” letter pairs are not specified, the values default to the current year. If the “SS” letter pair is not specified, the value defaults to 0.

EXIT STATUS

COMPATIBILITY
The obsolescent form of touch, where a time format is specified as the first argument, is supported. When no -r or -t option is specified, there are at least two arguments, and the first argument is a string of digits either eight or ten characters in length, the first argument is interpreted as a time specification of the form “MMDDhhmm[YY]”.

The “MM”, “DD”, “hh” and “mm” letter pairs are treated as their counterparts specified to the -t option. If the “YY” letter pair is in the range 39 to 99, the year is set to 1939 to 1999, otherwise, the year is set in the 21st century.

SEE ALSO
utimensat(2)

STANDARDS
The touch utility is expected to be a superset of the p1003.2 specification.

HISTORY
A touch utility appeared in AT&T UNIX.